文档章节

jQuery 对AMD的支持

不知道起什么名字
 不知道起什么名字
发布于 2016/11/30 23:51
字数 904
阅读 12
收藏 0

AMD 模块

AMD(异步模块定义,Asynchronous Module Definition)格式总体的目标是为现在的开发者提供一个可用的模块化 JavaScript 的解决方案。

AMD 模块格式本身是一个关于如何定义模块的提案,在这种定义下模块和依赖项都能够异步地进行加载。它有很多独特的优势,包括天生的异步及高度灵活等特性,这些特性能够解除常见的代码与模块标识间的那种紧密耦合。目前它已经被很多项目所接纳,包括jQuery(1.7)。

RequireJS

RequireJS是一个工具库,主要用于客户端的模块管理。它可以让客户端的代码分成一个个模块,实现异步或动态加载,从而提高代码的性能和可维护性。它的模块管理遵守AMD规范

jQuery 对AMD的支持

jQuery 1.7 开始支持将 jQuery 注册为一个AMD异步模块。有很多兼容的脚本加载器(包括 RequireJS 和 curl)都可以用一个异步模块格式来加载模块,这也就表示不需要太多 hack 就能让一切运行起来。可以看看jQuery 1.7 中的源码:

 

  1. // Expose jQuery as an AMD module, but only for AMD loaders that
  2. // understand the issues with loading multiple versions of jQuery
  3. // in a page that all might call define(). The loader will indicate
  4. // they have special allowances for multiple jQuery versions by
  5. // specifying define.amd.jQuery = true. Register as a named module,
  6. // since jQuery can be concatenated with other files that may use define,
  7. // but not use a proper concatenation script that understands anonymous
  8. // AMD modules. A named AMD is safest and most robust way to register.
  9. // Lowercase jquery is used because AMD module names are derived from
  10. // file names, and jQuery is normally delivered in a lowercase file name.
  11. if ( typeof define === "function" && define.amd && define.amd.jQuery ) {
  12. define( "jquery", [], function () { return jQuery; } );
  13. }

其工作的原理是,所使用的脚本加载器通过指定一个属性,即 define.amd.jQuery 为 true,来标明自己可以支持多个 jQuery 版本。如果有兴趣了解特定的实现细节的话,我们可以将 jQuery 注册为一个具名模块,因为可能会有这样的风险,即它可能被与其它使用了 AMD 的 define() 方法的文件拼合在一起,而没有使用一个合适的、理解匿名 AMD 模块定义的拼合脚本。

高版本的jQuery (1.11.1) 去掉了define.amd.jQuery判断:

 

  1. if ( typeof define === "function" && define.amd ) {
  2. define( "jquery", [], function() {
  3. return jQuery;
  4. });
  5. }

Require.js中使用jQuery

Require.js中使用jQuery非常方便,简单配置就可以了,例如:

 

  1. // 简单的配置
  2. require.config({
  3.  
  4. // RequireJS 通过一个相对的路径 baseUrl来加载所有代码。baseUrl通常被设置成data-main属性指定脚本的同级目录。
  5. baseUrl: "./js",
  6.  
  7. // 第三方脚本模块的别名,jquery比libs/jquery-1.11.1.min.js简洁明了;
  8. paths: {
  9.  
  10. "jquery": "libs/jquery-1.11.1.min.js"
  11.  
  12. }
  13.  
  14. });
  15.  
  16. // 开始使用jQuery 模块
  17. require(["jquery"], function ($) {
  18.  
  19. //你的代码
  20. //这里直接可以使用jquery的方法,比如:$( "#result" ).html( "Hello World!" );
  21.  
  22. });

Require.js中使用jQuery 插件

虽然jQuery的支持AMD的API, 这并不意味着jQuery插件也是和AMD兼容的。

一般的jQuery 插件格式:

 

  1. (function ($) {
  2. $.fn.m​​yPlugin = function () {
  3. //你自己的插件代码
  4. };
  5. })(jQuery);

不过我们稍微修改一下就可以使用Require.js加载一个jQuery插件:

 

  1. ;(function (factory) {
  2. if (typeof define === "function" && define.amd) {
  3. // AMD模式
  4. define([ "jquery" ], factory);
  5. } else {
  6. // 全局模式
  7. factory(jQuery);
  8. }
  9. }(function ($) {
  10. $.fn.jqueryPlugin = function () {
  11. //插件代码
  12. };
  13. }));

Require.js中使用jQuery UI组件

Require.js中使用jQuery UI组件也类似的,只要改造一下jQuery Widget Factory 代码就可以了,并且感觉jQuery UI的依赖关系加载就可以了。例如:

 

  1. ;(function (widgetFactory) {
  2.  
  3. if (typeof define === "function" && define.amd) {
  4. // AMD模式
  5. define("jquery.ui.widget", ["jquery"], function () {
  6.  
  7. widgetFactory(window.jQuery);
  8.  
  9. });
  10. } else {
  11. // 全局模式
  12. widgetFactory(window.jQuery);
  13. }
  14. }
  15. (function ($, undefined) {
  16.  
  17. // jQuery Widget Factory 代码
  18.  
  19. }));

本文转载自:http://www.css88.com/archives/4826

共有 人打赏支持
上一篇: ECharts2.0
下一篇: requirejs使用
不知道起什么名字
粉丝 2
博文 12
码字总数 7419
作品 0
南京
私信 提问
jQuery 1.7增加了对html5的支持

切图网(www.qietu.com)讯:jQuery最新版本添加了对html5的支持,发布的版 本号为jQuery1.7。 jQuery对我们来说一点也不陌生,作为一个第三发的js插件,影响程度居然影响了整个javascript书...

tyshymy
2012/02/06
0
0
两步实现将jquery作为Dojo的一个模块使用

jquery和dojo都需要1.7.x及以上版本,因为要支持Asynchronous Module Definition (AMD) API才行。 第一步: <script type="text/javascript" src="https://ajax.googleapis.com/ajax/libs/do......

javasql
2012/11/27
0
1
Javascript模块化编程(三):require.js的用法

一、为什么要用require.js? 最早的时候,所有Javascript代码都写在一个文件里面,只要加载这一个文件就够了。后来,代码越来越多,一个文件不够了,必须分成多个文件,依次加载。下面的网页...

rocet
2014/03/28
0
2
require.js入门学习(share)

最近的项目用到了require.js ,搜集一些资源留个备份,顺便分享给大家。   以下内容转自阮一峰老师的网络日志:http://www.ruanyifeng.com/blog/2012/11/require_js.html   更多学习资源...

雍雍_yoyo
2014/03/04
0
0
Javascript模块化编程:require.js的用法

作者: 阮一峰 日期: 2012年11月 7日 这个系列的第一部分和第二部分,介绍了Javascript模块原型和理论概念,今天介绍如何将它们用于实战。 我采用的是一个非常流行的库require.js。 一、为什...

java_T
2013/06/28
0
0

没有更多内容

加载失败,请刷新页面

加载更多

docker部署springboot项目

安装docker 菜鸟教程 springboot项目 maven依赖 <?xml version="1.0" encoding="UTF-8"?><project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001......

yimingkeji
今天
10
0
ios多个target

1.建立3个target,分别为heroone,heroone test,heroone dev;分别为正式环境,test环境,dev环境 2.注意取消掉autocreate以防止名字不对,分别以Duplicate的方式建立另外两个scheme 3.创建...

HeroHY
今天
5
0
php获取客户端IP

php获取客户端IP 首先先阅读关于IP真实性安全的文章:如何正確的取得使用者 IP? 「任何從客戶端取得的資料都是不可信任的!」 HTTP_CLIENT_IP头是有的,但未成标准,不一定服务器都实现。 ...

DrChenXX
昨天
0
0
. The valid characters are defined in RFC 7230 and RFC 问题

通过这里的回答,我们可以知道: Tomcat在 7.0.73, 8.0.39, 8.5.7 版本后,添加了对于http头的验证。 具体来说,就是添加了些规则去限制HTTP头的规范性 参考这里 具体来说: org.apache.tom...

west_coast
昨天
1
0
刷leetcode第704题-二分查找

今天双十一买的算法书到货了,路上刷到有人说的这个题,借(chao)鉴(xi)一下别人的思路,这个是C++标准库里面的经典方法,思路精巧,优雅好品味 int search(int* nums, int numsSize, in...

锟斤拷烫烫烫
昨天
3
0

没有更多内容

加载失败,请刷新页面

加载更多

返回顶部
顶部